//---------------------------------------------
// 複数サイズの画像を生成するプログラム
//---------------------------------------------
var SIZES = [
  {width:29*1, height: 29*1, format:"png", fname:"icon-29x1.png"},
  {width:40*1, height: 40*1, format:"png", fname:"icon-40x1.png"},
  {width:60*1, height: 60*1, format:"png", fname:"icon-60x1.png"},
  {width:76*1, height: 76*1, format:"png", fname:"icon-76x1.png"},
  {width:29*2, height: 29*2, format:"png", fname:"icon-29x2.png"},
  {width:40*2, height: 40*2, format:"png", fname:"icon-40x2.png"},
  {width:60*2, height: 60*2, format:"png", fname:"icon-60x2.png"},
  {width:76*2, height: 76*2, format:"png", fname:"icon-76x2.png"},
];

// JavaのクラスをJavaScriptで使いやすく宣言
var ImageIO = javax.imageio.ImageIO;
var Image = java.awt.Image;
var FileInputStream = java.io.FileInputStream;
var BufferedImage = java.awt.image.BufferedImage;

// ドラッグされたファイルを処理する
for (var i = 0; i < arguments.length; i++) {
  var inFile = arguments[i];
  resizeMultiSize(inFile);
}
print("ok.\n");

// ファイルを複数サイズにリサイズする
function resizeMultiSize(inFile) {
  var img = loadImage(inFile);
  for (var i = 0; i < SIZES.length; i++) {
    var sz = SIZES[i];
    var outFile = sz.fname;
    resizeImage(img, sz, outFile);
  }
}

// 画像オブジェクトimgをszの形式でoutFileに出力する
function resizeImage(img, sz, outFile) {
  var i = resize(img, sz.width, sz.height);
  ImageIO.write(i, sz.format, new java.io.File(outFile));
  print("- " + outFile);
}

// 画像を読み込む
function loadImage(fname) {
  var fis = new FileInputStream(fname);
  return ImageIO.read(fis);
}
// 画像をリサイズ
function resize(image, dw, dh) {
  var thumb = new BufferedImage(dw, dh, image.getType());
  var im = image.getScaledInstance(
    dw, dh, Image.SCALE_AREA_AVERAGING);
  thumb.getGraphics().drawImage(im,
    0, 0, dw, dh, null);
  return thumb;
}


